about summary refs log tree commit diff stats
path: root/bootstrap/setup/setup.sh
diff options
context:
space:
mode:
authorene <ene@sils.li>2023-02-21 12:27:53 +0100
committerene <ene@sils.li>2023-02-21 12:27:53 +0100
commit78685e847a282f132057ebe0bac20ddba186d518 (patch)
tree2b392b6321918008dcdff8c4f8c7f53275026557 /bootstrap/setup/setup.sh
parentFix(system): Fix typo in fs names (diff)
downloadnixos-config-78685e847a282f132057ebe0bac20ddba186d518.tar.gz
nixos-config-78685e847a282f132057ebe0bac20ddba186d518.zip
Feat(bootstrap): Add a setup script
Diffstat (limited to '')
-rwxr-xr-xbootstrap/setup/setup.sh37
1 files changed, 37 insertions, 0 deletions
diff --git a/bootstrap/setup/setup.sh b/bootstrap/setup/setup.sh
new file mode 100755
index 00000000..9f102f43
--- /dev/null
+++ b/bootstrap/setup/setup.sh
@@ -0,0 +1,37 @@
+#! /usr/bin/env dash
+# shellcheck disable=SC2086
+# shellcheck source=/dev/null
+. %SHELL_LIBRARY_PATH
+export LIB_TEMP_DIR_FOR_SCRIPT="$(mktemp -d)"
+
+msg "Select a host-config:"
+hosts=$(mktmp);
+host="";
+
+awk -F "." '/inputs.nixpkgs.lib.nixosSystem/{print $1}' "$(tmp 'curl https://git.sils.li/ene/nixos-config/raw/branch/prime/flake/nixosConfigurations/default.nix 2> /dev/null')" | awk '{print $1}' > $hosts;
+
+while ! grep "$host" "$hosts" > /dev/null || [ "$(printf "%s" "$host" | wc -c)" -eq 0 ]; do
+    i=1;
+    while read -r ho ; do
+        printf "%4s) %s \n" "$i" "$ho";
+        i=$((i+1));
+    done < "$hosts"
+    printf "%4s) Exit\n" "q"
+    readp  "Enter a option: " host
+
+    [ "$host" = "q" ] && exit 1
+    host=$(awk -v i="$host" '{if (NR==i) {print $0}}' "$hosts");
+    if ! grep "$host" "$hosts" > /dev/null || [ "$(printf "%s" "$host" | wc -c)" -eq 0 ]; then
+        warning "No host selected. Select a host to continue.\n"
+    fi
+done
+nixos-install --flake git+https://git.sils.li/ene/nixos-config#${host} --no-root-passwd
+
+# clone the git config
+git clone https://git.sils.li/ene/nixos-config /mnt/etc/nixos
+
+# setup persistent home dir
+mkdir -p /srv/home
+chmod 777 /srv/home
+
+if [ -d "$LIB_TEMP_DIR_FOR_SCRIPT" ];then rm -r "$LIB_TEMP_DIR_FOR_SCRIPT"; fi